package com.admost.flutter_plugin_deneme_example

import admost.sdk.AdMostViewBinder
import com.admost.admost_flutter_plugin.AdmostFLTNativeAdBinder
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.plugins.util.GeneratedPluginRegister

class MainActivity: FlutterActivity() {

    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)

        val binder: AdMostViewBinder = admost.sdk.AdMostViewBinder.Builder(R.layout.custom_native_250)
            .iconImageId(R.id.ad_app_icon)
            .titleId(R.id.ad_headline)
            .callToActionId(R.id.ad_call_to_action)
            .textId(R.id.ad_body)
            .attributionId(R.id.ad_attribution)
            .mainImageId(R.id.ad_image)
            .backImageId(R.id.ad_back)
            .privacyIconId(R.id.ad_privacy_icon)
            .isRoundedMode(true)
            .build()

        AdmostFLTNativeAdBinder.getInstance().binder = binder;

        GeneratedPluginRegister.registerGeneratedPlugins(flutterEngine)
    }
}
