//
//  AdmostInterstitialDelegate.m
//  admost_flutter_plugin
//
//  Created by Mehmet Karagöz on 6.12.2019.
//

#import "AdmostInterstitialDelegate.h"

@implementation AdmostInterstitialDelegate {
    FlutterMethodChannel *_channel;
}

#pragma mark - NSObject

+ (instancetype)delegateWithChannel:(FlutterMethodChannel *)channel {
    return [[[self class] alloc] initWithChannel:channel];
}

- (instancetype)initWithChannel:(FlutterMethodChannel *)channel {
    if (!(self = [super init]))
        return nil;
    _channel = channel;
    return self;
}

#pragma mark - <AMRInterstitialDelegate>

- (void)didReceiveInterstitial:(AMRInterstitial *)interstitial {
    [_channel invokeMethod:@"loaded" arguments:@{
        @"network": interstitial.networkName ,
        @"ecpm": interstitial.ecpm 
    }];
}

- (void)didFailToReceiveInterstitial:(AMRInterstitial *)interstitial error:(AMRError *)error {
       [_channel invokeMethod:@"failedToLoad" arguments:@{
        @"errorCode": [NSNumber numberWithInt:error.errorCode] ,
        @"errorMessage": error.errorDescription
    }];
}

- (void)didShowInterstitial:(AMRInterstitial *)interstitial {
    [_channel invokeMethod:@"opened" arguments:@{
        @"network": interstitial.networkName ,
    }];
}

- (void)didFailToShowInterstitial:(AMRInterstitial *)interstitial error:(AMRError *)error {
    [_channel invokeMethod:@"failedToShow" arguments:@{
        @"errorCode": [NSNumber numberWithInt:error.errorCode] ,
        @"errorMessage": error.errorDescription
    }];
}

- (void)didClickInterstitial:(AMRInterstitial *)interstitial {
    [_channel invokeMethod:@"clicked" arguments:@{
        @"network": interstitial.networkName ,
    }];
}

- (void)didDismissInterstitial:(AMRInterstitial *)interstitial {
    [_channel invokeMethod:@"dismissed" arguments:nil];
}

@end
